diff --git a/src/test/test_dir.c b/src/test/test_dir.c
index 4b86be4..e525c78 100644
--- a/src/test/test_dir.c
+++ b/src/test/test_dir.c
@@ -88,7 +88,7 @@ test_dir_formats(void)
   get_platform_str(platform, sizeof(platform));
   r1 = tor_malloc_zero(sizeof(routerinfo_t));
   r1->address = tor_strdup("18.244.0.1");
-  r1->addr = 0xc0a80001u; /* 192.168.0.1 */
+  tor_addr_from_ipv4h(&r1->addr, 0xc0a80001u); /* 192.168.0.1 */
   r1->cache_info.published_on = 0;
   r1->or_port = 9000;
   r1->dir_port = 9003;
@@ -113,7 +113,7 @@ test_dir_formats(void)
   ex2->prt_min = ex2->prt_max = 24;
   r2 = tor_malloc_zero(sizeof(routerinfo_t));
   r2->address = tor_strdup("1.1.1.1");
-  r2->addr = 0x0a030201u; /* 10.3.2.1 */
+  tor_addr_from_ipv4h(&r2->addr, 0x0a030201u); /* 10.3.2.1 */
   r2->platform = tor_strdup(platform);
   r2->cache_info.published_on = 5;
   r2->or_port = 9005;
@@ -656,7 +656,7 @@ test_same_voter(networkstatus_voter_info_t *v1,
   test_streq(v1->nickname, v2->nickname);
   test_memeq(v1->identity_digest, v2->identity_digest, DIGEST_LEN);
   test_streq(v1->address, v2->address);
-  test_eq(v1->addr, v2->addr);
+  test_assert(tor_addr_eq(&v1->addr, &v2->addr));
   test_eq(v1->dir_port, v2->dir_port);
   test_eq(v1->or_port, v2->or_port);
   test_streq(v1->contact, v2->contact);
@@ -725,6 +725,7 @@ test_dir_v3_networkstatus(void)
   routerstatus_t *rs;
   char *v1_text=NULL, *v2_text=NULL, *v3_text=NULL, *consensus_text=NULL, *cp;
   smartlist_t *votes = smartlist_create();
+  tor_addr_t addrt;
 
   /* For generating the two other consensuses. */
   char *detached_text1=NULL, *detached_text2=NULL;
@@ -780,7 +781,7 @@ test_dir_v3_networkstatus(void)
   voter = tor_malloc_zero(sizeof(networkstatus_voter_info_t));
   voter->nickname = tor_strdup("Voter1");
   voter->address = tor_strdup("1.2.3.4");
-  voter->addr = 0x01020304;
+  tor_addr_from_ipv4h(&voter->addr,0x01020304);
   voter->dir_port = 80;
   voter->or_port = 9000;
   voter->contact = tor_strdup("voter@example.com");
@@ -799,7 +800,7 @@ test_dir_v3_networkstatus(void)
   strlcpy(rs->nickname, "router2", sizeof(rs->nickname));
   memset(rs->identity_digest, 3, DIGEST_LEN);
   memset(rs->descriptor_digest, 78, DIGEST_LEN);
-  rs->addr = 0x99008801;
+  tor_addr_from_ipv4h(&rs->addr,0x99008801);
   rs->or_port = 443;
   rs->dir_port = 8000;
   /* all flags but running cleared */
@@ -815,7 +816,7 @@ test_dir_v3_networkstatus(void)
   strlcpy(rs->nickname, "router1", sizeof(rs->nickname));
   memset(rs->identity_digest, 5, DIGEST_LEN);
   memset(rs->descriptor_digest, 77, DIGEST_LEN);
-  rs->addr = 0x99009901;
+  tor_addr_from_ipv4h(&rs->addr, 0x99009901);
   rs->or_port = 443;
   rs->dir_port = 0;
   rs->is_exit = rs->is_stable = rs->is_fast = rs->is_flagged_running =
@@ -831,7 +832,7 @@ test_dir_v3_networkstatus(void)
   strlcpy(rs->nickname, "router3", sizeof(rs->nickname));
   memset(rs->identity_digest, 33, DIGEST_LEN);
   memset(rs->descriptor_digest, 79, DIGEST_LEN);
-  rs->addr = 0xAA009901;
+  tor_addr_from_ipv4h(&rs->addr,0xAA009901);
   rs->or_port = 400;
   rs->dir_port = 9999;
   rs->is_authority = rs->is_exit = rs->is_stable = rs->is_fast =
@@ -848,7 +849,7 @@ test_dir_v3_networkstatus(void)
   strlcpy(rs->nickname, "router4", sizeof(rs->nickname));
   memset(rs->identity_digest, 34, DIGEST_LEN);
   memset(rs->descriptor_digest, 47, DIGEST_LEN);
-  rs->addr = 0xC0000203;
+  tor_addr_from_ipv4h(&rs->addr,0xC0000203);
   rs->or_port = 500;
   rs->dir_port = 1999;
   /* Running flag (and others) cleared */
@@ -875,7 +876,8 @@ test_dir_v3_networkstatus(void)
   voter = smartlist_get(v1->voters, 0);
   test_streq(voter->nickname, "Voter1");
   test_streq(voter->address, "1.2.3.4");
-  test_eq(voter->addr, 0x01020304);
+  tor_addr_from_ipv4h(&addrt, 0x01020304);
+  test_assert(tor_addr_eq(&voter->addr, &addrt));
   test_eq(voter->dir_port, 80);
   test_eq(voter->or_port, 9000);
   test_streq(voter->contact, "voter@example.com");
@@ -895,7 +897,8 @@ test_dir_v3_networkstatus(void)
              "\x3\x3\x3\x3\x3\x3\x3\x3\x3\x3\x3\x3\x3\x3\x3\x3\x3\x3\x3\x3",
              DIGEST_LEN);
   test_memeq(rs->descriptor_digest, "NNNNNNNNNNNNNNNNNNNN", DIGEST_LEN);
-  test_eq(rs->addr, 0x99008801);
+  tor_addr_from_ipv4h(&addrt, 0x99008801);
+  test_assert(tor_addr_eq(&rs->addr, &addrt));
   test_eq(rs->or_port, 443);
   test_eq(rs->dir_port, 8000);
   test_eq(vrs->flags, U64_LITERAL(16)); // no flags except "running"
@@ -909,7 +912,8 @@ test_dir_v3_networkstatus(void)
              "\x5\x5\x5\x5\x5\x5\x5\x5\x5\x5\x5\x5\x5\x5\x5\x5\x5\x5\x5\x5",
              DIGEST_LEN);
   test_memeq(rs->descriptor_digest, "MMMMMMMMMMMMMMMMMMMM", DIGEST_LEN);
-  test_eq(rs->addr, 0x99009901);
+  tor_addr_from_ipv4h(&addrt, 0x99009901);
+  test_assert(tor_addr_eq(&rs->addr, &addrt));
   test_eq(rs->or_port, 443);
   test_eq(rs->dir_port, 0);
   test_eq(vrs->flags, U64_LITERAL(254)); // all flags except "authority."
@@ -942,7 +946,7 @@ test_dir_v3_networkstatus(void)
   tor_free(voter->address);
   voter->nickname = tor_strdup("Voter2");
   voter->address = tor_strdup("2.3.4.5");
-  voter->addr = 0x02030405;
+  tor_addr_from_ipv4h(&voter->addr,0x02030405);
   crypto_pk_get_digest(cert2->identity_key, voter->identity_digest);
   smartlist_add(vote->known_flags, tor_strdup("MadeOfCheese"));
   smartlist_add(vote->known_flags, tor_strdup("MadeOfTin"));
@@ -984,7 +988,7 @@ test_dir_v3_networkstatus(void)
   tor_free(voter->address);
   voter->nickname = tor_strdup("Voter3");
   voter->address = tor_strdup("3.4.5.6");
-  voter->addr = 0x03040506;
+  tor_addr_from_ipv4h(&voter->addr,0x03040506);
   crypto_pk_get_digest(cert3->identity_key, voter->identity_digest);
   /* This one has a legacy id. */
   memset(voter->legacy_id_digest, (int)'A', DIGEST_LEN);
@@ -1091,7 +1095,8 @@ test_dir_v3_networkstatus(void)
   test_streq(rs->nickname, "router1");
   test_memeq(rs->descriptor_digest, "MMMMMMMMMMMMMMMMMMMM", DIGEST_LEN);
   test_eq(rs->published_on, now-1000);
-  test_eq(rs->addr, 0x99009901);
+  tor_addr_from_ipv4h(&addrt, 0x99009901);
+  test_assert(tor_addr_eq(&rs->addr,&addrt));
   test_eq(rs->or_port, 443);
   test_eq(rs->dir_port, 0);
   test_assert(!rs->is_authority);
diff --git a/src/tools/tor-gencert.c b/src/tools/tor-gencert.c
index a04edda..98345d7 100644
--- a/src/tools/tor-gencert.c
+++ b/src/tools/tor-gencert.c
@@ -161,18 +161,16 @@ parse_commandline(int argc, char **argv)
     } else if (!strcmp(argv[i], "-v")) {
       verbose = 1;
     } else if (!strcmp(argv[i], "-a")) {
-      uint32_t addr;
+      tor_addr_t addr;
       uint16_t port;
       char b[INET_NTOA_BUF_LEN];
-      struct in_addr in;
       if (i+1>=argc) {
         fprintf(stderr, "No argument to -a\n");
         return 1;
       }
       if (parse_addr_port(LOG_ERR, argv[++i], NULL, &addr, &port)<0)
         return 1;
-      in.s_addr = htonl(addr);
-      tor_inet_ntoa(&in, b, sizeof(b));
+      tor_addr_to_str(&addr,b,sizeof(b),1);
       address = tor_malloc(INET_NTOA_BUF_LEN+32);
       tor_snprintf(address, INET_NTOA_BUF_LEN+32, "%s:%d", b, (int)port);
     } else if (!strcmp(argv[i], "--create-identity-key")) {
diff --git a/src/tools/tor-resolve.c b/src/tools/tor-resolve.c
index 12349d9..b1a74ed 100644
--- a/src/tools/tor-resolve.c
+++ b/src/tools/tor-resolve.c
@@ -74,14 +74,14 @@ build_socks_resolve_request(char **out,
     memcpy((*out)+8+strlen(username)+1, hostname, strlen(hostname)+1);
   } else if (version == 5) {
     int is_ip_address;
-    struct in_addr in;
+    tor_addr_t addr;
     size_t addrlen;
-    is_ip_address = tor_inet_aton(hostname, &in);
+    is_ip_address = tor_inet_pton(AF_UNSPEC, hostname, &addr);
     if (!is_ip_address && reverse) {
       log_err(LD_GENERAL, "Tried to do a reverse lookup on a non-IP!");
       return -1;
     }
-    addrlen = reverse ? 4 : 1 + strlen(hostname);
+    addrlen = reverse ? (tor_addr_family(&addr) == AF_INET ? 4 : 16) : 1 + strlen(hostname);
     len = 6 + addrlen;
     *out = tor_malloc(len);
     (*out)[0] = 5; /* SOCKS version 5 */
@@ -89,7 +89,7 @@ build_socks_resolve_request(char **out,
     (*out)[2] = 0; /* reserved. */
     (*out)[3] = reverse ? 1 : 3;
     if (reverse) {
-      set_uint32((*out)+4, in.s_addr);
+      memcpy((*out)+4, tor_addr_raw(&addr), addrlen);
     } else {
       (*out)[4] = (char)(uint8_t)(addrlen - 1);
       memcpy((*out)+5, hostname, addrlen - 1);
@@ -109,7 +109,7 @@ build_socks_resolve_request(char **out,
 static int
 parse_socks4a_resolve_response(const char *hostname,
                                const char *response, size_t len,
-                               uint32_t *addr_out)
+                               tor_addr_t *addr_out)
 {
   uint8_t status;
   tor_assert(response);
@@ -140,7 +140,8 @@ parse_socks4a_resolve_response(const char *hostname,
     return -1;
   }
 
-  *addr_out = ntohl(get_uint32(response+4));
+  /* Note that there is no IPv6 support in SOCKS4(a) */
+  tor_addr_from_ipv4n(addr_out, get_uint32(response+4));
   return 0;
 }
 
@@ -177,12 +178,12 @@ socks5_reason_to_string(char reason)
  * address (in host order) into *<b>result_addr</b>.
  */
 static int
-do_resolve(const char *hostname, uint32_t sockshost, uint16_t socksport,
+do_resolve(const char *hostname, tor_addr_t *sockshost, uint16_t socksport,
            int reverse, int version,
-           uint32_t *result_addr, char **result_hostname)
+           tor_addr_t *result_addr, char **result_hostname)
 {
   int s;
-  struct sockaddr_in socksaddr;
+  struct sockaddr_storage socksaddr;
   char *req = NULL;
   ssize_t len = 0;
 
@@ -190,19 +191,17 @@ do_resolve(const char *hostname, uint32_t sockshost, uint16_t socksport,
   tor_assert(result_addr);
   tor_assert(version == 4 || version == 5);
 
-  *result_addr = 0;
+  memset(result_addr, 0, sizeof(*result_addr));
   *result_hostname = NULL;
 
-  s = tor_open_socket(PF_INET,SOCK_STREAM,IPPROTO_TCP);
+  s = tor_open_socket(tor_addr_protocol(sockshost),SOCK_STREAM,IPPROTO_TCP);
   if (s<0) {
     log_sock_error("creating_socket", -1);
     return -1;
   }
 
-  memset(&socksaddr, 0, sizeof(socksaddr));
-  socksaddr.sin_family = AF_INET;
-  socksaddr.sin_port = htons(socksport);
-  socksaddr.sin_addr.s_addr = htonl(sockshost);
+  tor_addr_to_sockaddr(sockshost, socksport, &socksaddr, sizeof(socksaddr));
+
   if (connect(s, (struct sockaddr*)&socksaddr, sizeof(socksaddr))) {
     log_sock_error("connecting to SOCKS host", s);
     return -1;
@@ -281,14 +280,15 @@ do_resolve(const char *hostname, uint32_t sockshost, uint16_t socksport,
     if (reply_buf[3] == 1) {
       /* IPv4 address */
       if (read_all(s, reply_buf, 4, 1) != 4) {
-        log_err(LD_NET, "Error reading address in socks5 response.");
+        log_err(LD_NET, "Error reading IPv4 address in socks5 response.");
         return -1;
       }
-      *result_addr = ntohl(get_uint32(reply_buf));
+      tor_addr_from_ipv4n(result_addr, get_uint32(reply_buf));
     } else if (reply_buf[3] == 3) {
+      /* Domain name */
       size_t result_len;
       if (read_all(s, reply_buf, 1, 1) != 1) {
-        log_err(LD_NET, "Error reading address_length in socks5 response.");
+        log_err(LD_NET, "Error reading hostname address_length in socks5 response.");
         return -1;
       }
       result_len = *(uint8_t*)(reply_buf);
@@ -298,6 +298,13 @@ do_resolve(const char *hostname, uint32_t sockshost, uint16_t socksport,
         return -1;
       }
       (*result_hostname)[result_len] = '\0';
+    } else if (reply_buf[3] == 4) {
+      /* IPv6 address */
+      if (read_all(s, reply_buf, 16, 1) != 16) {
+        log_err(LD_NET, "Error reading IPv6 address in socks5 response.");
+        return -1;
+      }
+      tor_addr_from_ipv6_bytes(result_addr, reply_buf);
     }
   }
 
@@ -308,7 +315,7 @@ do_resolve(const char *hostname, uint32_t sockshost, uint16_t socksport,
 static void
 usage(void)
 {
-  puts("Syntax: tor-resolve [-4] [-v] [-x] [-F] [-p port] "
+  puts("Syntax: tor-resolve [-4] [-5] [-v] [-x] [-F] [-p port] "
        "hostname [sockshost:socksport]");
   exit(1);
 }
@@ -317,13 +324,11 @@ usage(void)
 int
 main(int argc, char **argv)
 {
-  uint32_t sockshost;
+  tor_addr_t sockshost, result;
   uint16_t socksport = 0, port_option = 0;
   int isSocks4 = 0, isVerbose = 0, isReverse = 0, force = 0;
   char **arg;
   int n_args;
-  struct in_addr a;
-  uint32_t result = 0;
   char *result_hostname = NULL;
   char buf[INET_NTOA_BUF_LEN];
   log_severity_list_t *s = tor_malloc_zero(sizeof(log_severity_list_t));
@@ -385,8 +390,8 @@ main(int argc, char **argv)
   add_stream_log(s, "<stderr>", fileno(stderr));
 
   if (n_args == 1) {
-    log_debug(LD_CONFIG, "defaulting to localhost");
-    sockshost = 0x7f000001u; /* localhost */
+    log_debug(LD_CONFIG, "defaulting to IPv4 localhost");
+    tor_addr_from_loopback(&sockshost, AF_INET);
     if (port_option) {
       log_debug(LD_CONFIG, "Using port %d", (int)port_option);
       socksport = port_option;
@@ -417,7 +422,7 @@ main(int argc, char **argv)
     return 1;
   }
 
-  if (do_resolve(arg[0], sockshost, socksport, isReverse,
+  if (do_resolve(arg[0], &sockshost, socksport, isReverse,
                  isSocks4 ? 4 : 5, &result,
                  &result_hostname))
     return 1;
@@ -425,8 +430,7 @@ main(int argc, char **argv)
   if (result_hostname) {
     printf("%s\n", result_hostname);
   } else {
-    a.s_addr = htonl(result);
-    tor_inet_ntoa(&a, buf, sizeof(buf));
+    tor_addr_to_str(&result, buf, sizeof(buf),1);
     printf("%s\n", buf);
   }
   return 0;
diff --git a/src/win32/orconfig.h b/src/win32/orconfig.h
index 5483b6d..22f9272 100644
--- a/src/win32/orconfig.h
+++ b/src/win32/orconfig.h
@@ -42,9 +42,6 @@
 /* Define to 1 if you have the <grp.h> header file. */
 #undef HAVE_GRP_H
 
-/* Define to 1 if you have the `inet_aton' function. */
-#undef HAVE_INET_ATON
-
 /* Define to 1 if you have the <inttypes.h> header file. */
 /* #define HAVE_INTTYPES_H */
 
